* decode base64 line
*
* this source is 'free' and 'not guaranteed'
* 10, Jan, 2000 Rick <shonma@geocities.co.jp>
*	based on aish by Hiroyuki Ogasawara
*
* (usege)
*	int decbenc(char *dest, char *src);
*
* (arguments)
*	dest ... pointer to destination buffer
*	src  ... pointer to source buffer
*
* (return value)
*	number of decoded characters
*	-1   ... error. bad character exists
*

*	NO_APP

	.cpu 68000

*	X68	GCC	Develop

LF	equ	$0a

	.even
	.text

	.even
	.global	_decbenc
_decbenc:
	movem.l	4(sp),a1-a2	*dest, src
	lea.l	base64_tbl(OPC),a0
	clr.w	d2
loop:
	move.b	(a2)+,d2	*c = *src++
	beq	rtn		*NULL ?

	cmpi.b	#LF,d2
	beq	rtn		*LF ?

	move.b	(a0,d2.w),d1	*code = base64_tbl[c]
	bmi	badcode
	lsl.w	#6,d1		*code << 6

	move.b	(a2)+,d2	*c = *src++
	bmi	badcode
	move.b	(a0,d2.w),d0	*base64_tbl[c]
	or.b	d0,d1		*code |= base64_tbl[c]
	lsl.l	#6,d1		*code << 6

	move.b	(a2)+,d2	*c = *src++
	move.b	(a0,d2.w),d0	*base64_tbl[c]
	bmi	badcode
	or.b	d0,d1		*code |= base64_tbl[c]
	lsl.l	#6,d1		*code << 6

	move.b	(a2)+,d2	*c = *src++
	move.b	(a0,d2.w),d0	*base64_tbl[c]
	bmi	badcode
	or.b	d0,d1		*code |= base64_tbl[c]

	move.l	d1,d0		*code
	swap.w	d0
	move.b	d0,(a1)+	* *dest++ = code >> 16

	cmpi.b	#'=',-2(a2)	*src[-2] == '=' ?
	beq	rtn

	rol.l	#8,d0
	move.b	d0,(a1)+	* *dest++ = (code >> 8) & 0xff

	cmpi.b	#'=',d2		*src[-1] == '=' ?
	beq	rtn

	move.b	d1,(a1)+	* *dest++ = code & 0xff
	bra	loop
rtn:
	clr.b	(a1)		* *dest = NULL
	move.l	a1,d0		*tail of output
	sub.l	4(sp),d0	*length of output
	rts
badcode:
	moveq.l	#-1,d0
	rts

	.even
base64_tbl:
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,62,-1,-1,-1,63
	.dc.b	52,53,54,55,56,57,58,59,60,61,-1,-1,-1, 0,-1,-1
	.dc.b	-1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14
	.dc.b	15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1
	.dc.b	-1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40
	.dc.b	41,42,43,44,45,46,47,48,49,50,51,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1

	.even
	.end
