#include	"mview.h"
#include	"dialog.h"
#include	<mm_alloc.h>
#include	<HS_wlib.h>
#include	<winop.h>
#include	<string.h>
#include	<iocslib.h>

#define	OKX1	68
#define	OKY1	52
#define	OKX2	107
#define	OKY2	67
#define	CLX1	148
#define	CLX2	187

static int	clipmenu( WindowID, EventInfo* );
static int	DialogExec( WindowID, EventInfo* );

void
dialog_close( dinf )
DIALOGINF	*dinf;
{
	if( dinf && dinf->wp )
	WindowClose( dinf->wp );
}

void
dialog_print( dinf, mes1, mes2 )
DIALOGINF	*dinf;
char	*mes1;
char	*mes2;
{
	DrawBuf	dbuf[3], *dp= dbuf;

	if( !dinf || !dinf->wp )	return;
	strcpy( dinf->mes1, mes1 );
	strcpy( dinf->mes2, mes2 );

	DrawSetLine( dp++, 8, 4, DIALOG_H - 8 - 1, 18 + 12 - 1, 1, OptionFill );
	DrawSetSymbol( dp++, 8,  4, mes1, AttrDefault, 12 );
	DrawSetSymbol( dp++, 8, 18, mes2, AttrDefault, 12 );
	WindowDraw( dinf->wp, dbuf, dp - dbuf );
}


static int
clipmenu( wp, info )
WindowID	wp;
EventInfo	*info;
{
	static char	*cmenu[]= { "paste" };
	int	num, px, py;

	WindowGetScreenPosition( wp, &px, &py );
	px+= info->x;
	py+= info->y;
	num= PopUpMenu( px-1, py, cmenu, sizeof cmenu/sizeof(char*), 12 );
	if( !num ){
		return UserSendPaste( wp, info );
	}else {
		return FALSE;
	}
}

static int
DialogExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[8], *dp= dbuf;
	DIALOGINF	*dinf;

	dinf= WindowGetClientPointer( wp );
	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON );
		return	TRUE;
	case EventClose:
		WindowClose( wp );
		free( dinf );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetSymbol( dp++,   8,  4, dinf->mes1, AttrDefault, 12 );
		DrawSetSymbol( dp++,   8, 18, dinf->mes2, AttrDefault, 12 );
		if( dinf->mode != PROGRESS ){
			DrawSetSymbol( dp++,  82, 54, "Ok"    , AttrDefault, 12 );
			DrawSetLine( dp++, OKX1, OKY1, OKX2, OKY2, ShadowUp, OptionShadow );
			if( dinf->mode != WARNING ){
				DrawSetSymbol( dp++, 150, 54, "Cancel", AttrDefault, 12 );
				DrawSetLine( dp++, CLX1, OKY1, CLX2, OKY2, ShadowUp, OptionShadow );
			}
			if( dinf->mode == KEYIN ){
				DrawSetLine( dp++,   8, 32, 251, 48, ShadowDown, OptionShadow );
			}
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		if( dinf->mode == KEYIN )	MgInputRedraw( &(dinf->mp) );
		return	TRUE;
	case EventKey:
	case EventMouseSwitch:
	case EventMouseEnter:
	case EventMouseOut:
		if( dinf->mode == KEYIN ){
			return	MgInputSendEvent( &(dinf->mp), info );
		}else {
			return FALSE;
		}
	case EventUser:
		if( dinf->mode == KEYIN ){
			switch( info->ComData ){
			case UserPaste:
			case UserString:
			case UserStrings:
				return	ClipGetKeyboardAll( wp, info );
			}
		}
		return FALSE;
	}
	return	FALSE;
}


int
dialog_open(title1, title2, mode, base)
char	*title1;
char	*title2;
int	mode;
WindowID	base;
{
	DIALOGINF	*dinf;
	EventInfo	myinfo;
	WindowID	cwp, nwp;
	int	ret;

	dinf = malloc(sizeof(DIALOGINF));
	if (!dinf)	return -1;

	strcpy(dinf->mes1, title1);
	strcpy(dinf->mes2, title2);
	dinf->mode = mode;
	dinf->wp = NULL;

	{
		int	x, y, h, v;
		WindowGetScreenPosition(base, &x, &y);
		h = HS_WindowGetSizeX(base) / 2;
		v = HS_WindowGetSizeY(base) / 2;
		cwp = WindowSimpleOpen(x + h + DIALOG_X, y + v + DIALOG_Y,
								DIALOG_H, DIALOG_V, NULL, DialogExec);
	}
	if (dinf->mode == KEYIN) {
		MgInputSimpleOpen(&(dinf->mp), 10, 34, cwp, 40, AttrDefault, 12);
		MgInputClear(&(dinf->mp));
	}
	WindowSetClientData(cwp, 0, dinf);
	WindowRedraw(cwp);
	dinf->wp = cwp;
	if (!mode)	return (int)dinf;

	MS_CURON();
	for (;;) {
		WindowGetEventInfo(&myinfo);
		nwp = WindowGetChild(WindowRootID, &myinfo);
		if (myinfo.option == EventKey && (nwp == cwp || nwp == base)) {
			if (myinfo.KeyCode == '\r') {
				ret = TRUE;
				break;	/* RET */
			} else if (myinfo.KeyCode == '\x1b' || myinfo.KeyCode == '\x07'
						&& mode != WARNING) {
				ret = FALSE;
				break;	/* ESC */
			} else {
				WindowSendEvent(cwp, &myinfo);
			}
		} else if (nwp == cwp) {
			if (myinfo.option == EventClose) {
				ret = FALSE;
				break;
			}
			if (myinfo.LeftON && myinfo.y >= OKY1
					&& myinfo.y <= OKY2) {
				if (myinfo.x >= OKX1 && myinfo.x <= OKX2) {
					ret = TRUE;
					break;	/* OK */
				} else if (myinfo.x >= CLX1 && myinfo.x <= CLX2
							&& mode != WARNING) {
					ret = FALSE;
					break;	/* Cancel */
				}
			} else if (myinfo.RightON && dinf->mode == KEYIN) {
				clipmenu(cwp, &myinfo);
			} else {
				WindowSendEvent(cwp, &myinfo);
			}
		} else if (nwp != base) {
			WindowSendEvent(nwp, &myinfo);
		}
	}

	if (mode == KEYIN) {
		if (ret) {
			strcpy(inputstr, dinf->mp.buf);
		}else {
			inputstr[0] = '\0';
		}
	}

	WindowClose(cwp);
	return ret;
}
