#include	"mview.h"
#include	"mdir.h"
/*#include	<stdlib.h>*/
#include	<mm_alloc.h>
#include	<io.h>
#include	<string.h>
#include	<doslib.h>

static DIRNAME *add_dchain(DIRNAME **dhead);
static void	del_dchain(DIRNAME *parent);
static void	insertdir(DIRNAME *listblock, int count, DIRNAME *parent);


static DIRNAME *
add_dchain(dhead)
DIRNAME	**dhead;
{
	DIRNAME	*newptr;

	newptr = malloc(sizeof(DIRNAME));
	if (!newptr) {
		ConsoleOpen();
		ConsolePrint("mview : ܂\n");
		return NULL;
	}

	newptr->next = NULL;
	if (*dhead) {
		DIRNAME	*parent = *dhead;

		while (parent->next)	parent = parent->next;
		parent->next = newptr;
	} else {
		*dhead = newptr;
	}
	return newptr;
}

static void
del_dchain(parent)
DIRNAME	*parent;
{
	while (parent) {
		DIRNAME	*child = parent->next;

		free(parent);
		parent = child;
	}
}

char *
dirdescend(curdir)
DIRNAME	*curdir;
{
	static char	family[FILNMAX];
	char	*wptr = family + FILNMAX - 1;
	DIRNAME	*tmpdir = curdir;

	*wptr = '\0';
	do {
		int	i = strlen(tmpdir->name);
		char	*rptr;

		rptr = tmpdir->name + i;
		for (; i; i--)	*--wptr = *--rptr;
		*--wptr = '\\';
	} while (tmpdir = tmpdir->parent);

	return ++wptr;
}

int
closedir(pos)
int	pos;
{
	int	i, j, k;

	j = DirList[pos]->depth;
	for (i = pos + 1; i < DirNow; i++) {
		if (DirList[i]->depth <= j)	break;
	}

	j = pos + 1;
	for (k = j; k < i; k++) {
		free(DirList[k]);
	}
	while (k < DirNow) {
		DirList[j++] = DirList[k++];
	}

	DirNow -= i - 1 - pos;
	realloc(DirList, DirNow * sizeof(DIRNAME*));

	DirList[pos]->flag = '+';
	if (DirPos > pos) {
		if (DirPos < i) {
			SetCDir(pos);
		} else {
			DirPos -= i - pos - 1;
		}
	}
	return	TRUE;
}

static void
insertdir(listblock, count, parent)
DIRNAME	*listblock;
int	count;
DIRNAME	*parent;
{
	int	i = 0, j;
	DIRNAME	**list;
	DIRNAME	*tmpdir = listblock;

	list = malloc((count + DirNow) * sizeof(DIRNAME*));
	if (!list) {
		del_dchain(listblock);
		return;
	}

	DirNow += count;
	if (DirList) {
		for (j = 0; i < DirNow;) {
			list[i++] = DirList[j];
			if (DirList[j++] == parent)	break;
		}
		while (tmpdir) {
			list[i++] = tmpdir;
			tmpdir = tmpdir->next;
		}
		while (i < DirNow) {
			list[i++] = DirList[j++];
		}
		free(DirList);
	} else {
		while (tmpdir) {
			list[i++] = tmpdir;
			tmpdir = tmpdir->next;
		}
	}
	DirList = list;
	return;
}

/* ŏ̃fBNgŃfBNgT */
int
DIRGET(targetdir, parent)
char	*targetdir;
DIRNAME	*parent;
{
	FILE	*fp;
	DIRNAME	*dhead = NULL, *tmpdir;
	int	DSaveFlag = FALSE;		/* DIR.INFۑ邩̃tO */
	int	newDirNow = 0;
	int	FoundFile;
	struct FILBUF	files_buffer;	/* files(fBNg)p */
	char	Temp[256], FileName[FILNMAX];

	strcpy(FileName, targetdir);
	strcat(FileName, "DIR.INF");

	if (fp = fopen(FileName, "rt")) {
		while (fgets(Temp, sizeof(Temp), fp)) {
			char	*r;

			tmpdir = add_dchain(&dhead);
			if (!tmpdir)	break;

			tmpdir->flag = FALSE;

			/* s̉s폜 */
			for (r = Temp; *r && *r != '\n'; r++);
			*r = '\0';

			for (r = Temp; *r && *r != '\t'; r++);
			if (*r) {
				*r++ = '\0';
			} else {
				r = Temp;
			}
			strcpy(tmpdir->name, Temp);
			strcpy(tmpdir->optname, r);
			newDirNow++;
		}
		fclose(fp);
	}

	strcpy(Temp, targetdir);
	strcat(Temp, "*.*");

	FoundFile = FILES(&files_buffer, Temp, 0x10);

	/* A */
	while (FoundFile >= 0) {
		/* JgfBNgƐefBNg͊O */
		if (strcmp(files_buffer.name, ".")
				&& strcmp(files_buffer.name, "..")) {

			/* fBNg DIR.INF ɂ邩ׂ */
			tmpdir = dhead;
			while (tmpdir) {
				if (!strcmpi(tmpdir->name, files_buffer.name)) {
					tmpdir->flag = TRUE;
					break;
				}
				tmpdir = tmpdir->next;
			}
			/* !strcmpi s = VfBNg */
			if (!tmpdir) {
				tmpdir = add_dchain(&dhead);
				if (!tmpdir)	break;

				tmpdir->flag = TRUE;
				strcpy(tmpdir->name, files_buffer.name);
				strcpy(tmpdir->optname, files_buffer.name);
				newDirNow++;
				DSaveFlag = TRUE;
			}
		}
		FoundFile = NFILES(&files_buffer);
	}

	{
		DIRNAME	*father = dhead;
		tmpdir = dhead;
		while (tmpdir) {
			DIRNAME	*child = tmpdir->next;
			if (tmpdir->flag) {
				father = tmpdir;

				tmpdir->flag = '+';
				tmpdir->parent = parent;
				tmpdir->depth = (parent)? (parent->depth + 1):0;
			} else {
				/* 폜ꂽfBNg */
				if (father == dhead) {
					father = dhead = child;
				} else {
					father->next = child;
				}
				free(tmpdir);
				newDirNow--;
				DSaveFlag = TRUE;
			}
			tmpdir = child;
		}
	}

	if (DSaveFlag) {
		/* DIR.INFZ[u */
		if (!(fp = fopen(FileName, "wt"))) {
			ConsoleOpen();
			ConsolePrint("mview : DIR.INFۑł܂\n");
		} else {
			tmpdir = dhead;
			while (tmpdir) {
				fprintf(fp, "%s\t%s\n", tmpdir->name, tmpdir->optname);
				tmpdir = tmpdir->next;
			}
			fclose(fp);
		}
	}
	if (newDirNow) {
		insertdir(dhead, newDirNow, parent);
		if (parent)	parent->flag = '-';
	} else {
		if (parent)	parent->flag = ' ';
	}

	return newDirNow;
}
